#!/bin/bash
#
#  This file is part of FindLibs For Rex 6000.
#
#  Create distribution kit
#
#  Copyright (C) 2002  Graham R. Cobb
#
#  FindLibs For Rex 6000 is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  FindLibs For Rex 6000 is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
#	Edit History
#
#	Graham R. Cobb	14 June 2002
#

#
# Function to copy all the normal files from any of the project directories
#
function copyoutput {
	copyif $1/*.c $2
	copyif $1/*.h $2
	copyif $1/build_info.dat $2
	copyif $1/makefile $2
	copyif $1/*.lib $2
	copyif $1/*.html $2
	copyif $1/*.rex $2
	copyif $1/*.bmp $2
	copyif $1/*.txt $2
	copyif $1/*.sh $2
	copyif $1/Copying $2
	copyif $1/Readme $2
	copyif $1/*.map $2
	if [[ -f $1/files.extra ]]
	then
		cp $1/files.extra $2
		xargs <$1/files.extra -i cp $1/{} $2
	fi
}

#
# Function to copy file(s) if they exist
#
function copyif {
	if [[ ( $# -gt 1 ) && -f $1 ]]
	then
		cp "$@"
	fi
}

#
# We assume the current directory is the distribution parent directory
#
# The contents of the library distribution directory ARE DELETED!
#
rm -rf findlibs-dist
mkdir findlibs-dist
cd findlibs-dist

#
# Note that now the current directory is the library distribution directory
#

#
# Copy and prepare the FindLibs directory
#
mkdir findlibs
copyoutput ../../Projects/findlibs/ findlibs/

#
# Prepare the distribution directory
#
copyif findlibs/Readme .
copyif findlibs/Copying .
copyif findlibs/findlibs.html index.html
copyif findlibs/findlibs.rex .

#
# Create the zip
#
rm ../findlibs.zip
zip -q ../findlibs.zip * -r findlibs
