/*
 *	This file is part of FindLibs For Rex 6000.
 *
 *	Find loaded library addins
 *
 *  Copyright (C) 2002  Graham R. Cobb
 *
 *  FindLibs For Rex 6000 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  FindLibs For Rex 6000 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 *	Edit History
 *
 *  Graham R. Cobb			2 January 2002
 */

#include "rex/rex.h"
#include <ctype.h>
#include <grclib.h>

extern char *title, *about;

void main()
{
#define ROW_HEIGHT 12
#define COL_PAGE 0
#define COL_SIG 50
#define COL_FINDLIB 120
	int row;
	unsigned short page;
	unsigned char *ptr = 0xa000, buffer[20];

	grc_display_message(about);
	
	DsClearScreen();
	DsPrintf(COL_PAGE, 0, 0, "PAGE");
	DsPrintf(COL_SIG, 0, 0, "SIGNATURE");
	DsPrintf(COL_FINDLIB, 0, 0, "FINDLIB");
	DsDisplayLine( 0,ROW_HEIGHT-1,240,0,0xff );//start x,y, end x offset, y offset, bitpattern
	row = ROW_HEIGHT;

	for (page=0; page<256; page++) {
		REGISTER_WRITE(REG_BANK2_HI, 0x00);
		REGISTER_WRITE(REG_BANK2_LO, page);
		if ( ptr[0]==0xc3 && ptr[1]==0x0d && ptr[2]==0x80 /* jp	start */
			&& isalnum(ptr[3]) && (ptr[4]==0 || isalnum(ptr[4])) && (ptr[5]==0 || isalnum(ptr[5])) /* Signature */
			&& ptr[6]==0x21 && ptr[7]==0x3a && ptr[8]==0x80 /* ld	hl,farret */
			&& ptr[9]==0xe5 /* push	hl */
			&& ptr[10]==0xc3 /* jp ... */ ) {
				/* Found a library */
	  			DsPrintf(COL_PAGE,row,0,grc_utoh(buffer, page)); // Print page
	  			buffer[0]=ptr[3];
	  			buffer[1]=ptr[4];
	  			buffer[2]=ptr[5];
	  			buffer[3]='\0';
	  			DsPrintf(COL_SIG,row,0,buffer); // Print signature
	  			DsPrintf(COL_FINDLIB,row,0,grc_utoh(buffer, findlib(buffer)));
				row += ROW_HEIGHT;
		}
	}

	/* Wait */
	grc_select();
}
